Index: /pjproject/trunk/pjlib-util/src/pjlib-util-test/http_client.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util-test/http_client.c	(revision 3094)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util-test/http_client.c	(revision 3095)
@@ -68,5 +68,5 @@
 
     while (!thread_quit) {
-	char *pkt = pj_pool_alloc(pool, srv->buf_size);
+	char *pkt = (char*)pj_pool_alloc(pool, srv->buf_size);
 	pj_ssize_t pkt_len;
 	int rc;
@@ -155,5 +155,5 @@
     send_size += sendsz;
 
-    sdata = pj_pool_alloc(pool, sendsz);
+    sdata = (char*)pj_pool_alloc(pool, sendsz);
     pj_create_random_string(sdata, sendsz);
     pj_ansi_sprintf(sdata, "\nSegment #%d\n", ++counter);
@@ -419,9 +419,21 @@
 #endif
 
-    pj_http_headers_add_elmt2(&param.headers, "Accept", 
-                              "image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-ms-application, application/vnd.ms-xpsdocument, application/xaml+xml, application/x-ms-xbap, application/x-shockwave-flash, application/vnd.ms-excel, application/vnd.ms-powerpoint, application/msword, */*");
-    pj_http_headers_add_elmt2(&param.headers, "Accept-Language", "en-sg");
-    pj_http_headers_add_elmt2(&param.headers, "User-Agent", 
-                              "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0; SLCC1; .NET CLR 2.0.50727; .NET CLR 3.0.04506)");
+    pj_http_headers_add_elmt2(&param.headers, (char*)"Accept",
+			     (char*)"image/gif, image/x-xbitmap, image/jpeg, "
+				    "image/pjpeg, application/x-ms-application,"
+				    " application/vnd.ms-xpsdocument, "
+			            "application/xaml+xml, "
+			            "application/x-ms-xbap, "
+			            "application/x-shockwave-flash, "
+			            "application/vnd.ms-excel, "
+			            "application/vnd.ms-powerpoint, "
+			            "application/msword, */*");
+    pj_http_headers_add_elmt2(&param.headers, (char*)"Accept-Language",
+	                      (char*)"en-sg");
+    pj_http_headers_add_elmt2(&param.headers, (char*)"User-Agent",
+                              (char*)"Mozilla/4.0 (compatible; MSIE 7.0; "
+                                     "Windows NT 6.0; SLCC1; "
+                                     ".NET CLR 2.0.50727; "
+                                     ".NET CLR 3.0.04506)");
     if (pj_http_req_create(pool, &url, timer_heap, ioqueue, 
                            &param, &hcb, &http_req))
@@ -523,6 +535,6 @@
 
     pj_http_req_param_default(&param);
-    pj_strset2(&param.method, "PUT");
-    data = pj_pool_alloc(pool, length);
+    pj_strset2(&param.method, (char*)"PUT");
+    data = (char*)pj_pool_alloc(pool, length);
     pj_create_random_string(data, length);
     pj_ansi_sprintf(data, "PUT test\n");
@@ -613,5 +625,5 @@
 
     pj_http_req_param_default(&param);
-    pj_strset2(&param.method, "PUT");
+    pj_strset2(&param.method, (char*)"PUT");
     total_size = 15383;
     send_size = 0;
@@ -694,5 +706,5 @@
 
     pj_http_req_param_default(&param);
-    pj_strset2(&param.method, "DELETE");
+    pj_strset2(&param.method, (char*)"DELETE");
     if (pj_http_req_create(pool, &url, timer_heap, ioqueue, 
                            &param, &hcb, &http_req))
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/http_client.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/http_client.c	(revision 3094)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/http_client.c	(revision 3095)
@@ -57,5 +57,5 @@
 };
 
-static char *http_protocol_names[NUM_PROTOCOL] =
+static const char *http_protocol_names[NUM_PROTOCOL] =
 {
     "HTTP",
@@ -76,5 +76,5 @@
 };
 
-static char *http_method_names[3] =
+static const char *http_method_names[3] =
 {
     "GET",
@@ -156,5 +156,5 @@
 }
 
-static char * get_protocol(const pj_str_t *protocol)
+static const char * get_protocol(const pj_str_t *protocol)
 {
     int i;
@@ -470,5 +470,5 @@
     pj_size_t i;
     char *cptr;
-    void *newdata;
+    char *newdata;
     pj_scanner scanner;
     pj_str_t s;
@@ -502,5 +502,5 @@
     response->content_length = -1;
 
-    newdata = pj_pool_alloc(pool, i);
+    newdata = (char*) pj_pool_alloc(pool, i);
     pj_memcpy(newdata, data, i);
 
@@ -524,5 +524,5 @@
 
     /* Parse the response headers. */
-    size = i - 2 - (scanner.curptr - (char *)newdata);
+    size = i - 2 - (scanner.curptr - newdata);
     if (size > 0) {
         status = http_headers_parse(scanner.curptr + 1, size, 
@@ -605,6 +605,6 @@
     pj_bzero(param, sizeof(*param));
     param->addr_family = pj_AF_INET();
-    pj_strset2(&param->method, http_method_names[HTTP_GET]);
-    pj_strset2(&param->version, HTTP_1_0);
+    pj_strset2(&param->method, (char*)http_method_names[HTTP_GET]);
+    pj_strset2(&param->version, (char*)HTTP_1_0);
     param->timeout.msec = PJ_HTTP_DEFAULT_TIMEOUT;
     pj_time_val_normalize(&param->timeout);
@@ -631,7 +631,9 @@
         pj_scan_get_until_ch(&scanner, ':', &s);
         if (!pj_stricmp2(&s, http_protocol_names[PROTOCOL_HTTP])) {
-            pj_strset2(&hurl->protocol, http_protocol_names[PROTOCOL_HTTP]);
+            pj_strset2(&hurl->protocol,
+        	       (char*)http_protocol_names[PROTOCOL_HTTP]);
         } else if (!pj_stricmp2(&s, http_protocol_names[PROTOCOL_HTTPS])) {
-            pj_strset2(&hurl->protocol, http_protocol_names[PROTOCOL_HTTPS]);
+            pj_strset2(&hurl->protocol,
+		       (char*)http_protocol_names[PROTOCOL_HTTPS]);
         } else {
             PJ_THROW(PJ_ENOTSUP); // unsupported protocol
@@ -913,5 +915,5 @@
         TRACE_((THIS_FILE, "%s", pkt.ptr));
     } else {
-        pkt.ptr = hreq->param.reqdata.data;
+        pkt.ptr = (char*)hreq->param.reqdata.data;
         pkt.slen = hreq->param.reqdata.size;
     }